//empirecolors.cs

// stole this from slayer (shhhh)
function rgbToHex(%rgb)
{
	//use % to find remainder
	%r = getWord(%rgb,0);
	if(%r <= 1)
		%r = %r * 255;
	%g = getWord(%rgb,1);
	if(%g <= 1)
		%g = %g * 255;
	%b = getWord(%rgb,2);
	if(%b <= 1)
		%b = %b * 255;
	%a = "0123456789ABCDEF";

	%r = getSubStr(%a,(%r-(%r % 16))/16,1) @ getSubStr(%a,(%r % 16),1);
	%g = getSubStr(%a,(%g-(%g % 16))/16,1) @ getSubStr(%a,(%g % 16),1);
	%b = getSubStr(%a,(%b-(%b % 16))/16,1) @ getSubStr(%a,(%b % 16),1);

	return %r @ %g @ %b;
}

function serverCmdRGBToHex(%c,%r,%g,%b)
{

	if(%r < 256 && %r >= 0 && %g < 256 && %g >= 0 && %b < 256 && %b >= 0)
	{

		%col = rgbToHex(%r SPC %g SPC %b);
		%str = "<color:" @ %col @ ">";
	
		messageClient(%c,'',%str @ %r SPC %g SPC %b SPC "\c6is" SPC %str @ %col SPC "\c6in hex format.");

	}
	else
	{

		messageClient(%c,'',"You must use values under 256 and above 0, cause... rgb. yeaaah.");

	}

}




function serverCmdEmpireColor(%c,%col)
{

	if(strLen(%col) == 6)
	{

		%colStr = "<color:" @ %col @ ">";

		%c.clanPrefix = %colStr @ "";
		%c.empireColor = %colStr;

		messageClient(%c,'',"\c6Your empire color is now" @ %colStr SPC %col);

		%gotColor = true;

	}

	if(%col <= 100 && !%gotColor)
	{

		%colFromSet = getColorIDTable(%col-1);

		if(%color !$= "1.000000 0.000000 1.000000 0.000000")
		{

			%colFromSetConv = rgbToHex(%colFromSet);

			%colStr = "<color:" @ %colFromSetConv @ ">";

			%c.clanPrefix = %colStr @ "";
			%c.empireColor = %colStr;

			messageClient(%c,'',"\c6Your empire color is now" @ %colStr SPC %colFromSetConv);

			%gotColor = true;

		}

	}

	if(%col $= "" && !%gotColor)
	{

		%c.empireColor = "";
		%c.clanPrefix = "";

		messageClient(%c,'',"If you were clearing your color, ignore this. Otherwise, use a number under 100 or a hex code for your empire color. /rgbtohex exists if you need to convert colors from RGB to hex.");

	}

}

exec("./merpvar.cs");
if(!$MrepPref::NameCharLimit){ $MerpPref::NameCharLimit = 36; }
export("$MerpPref::*","./merpvar.cs");

function serverCmdEmpireName(%c,%n,%n2,%n3)
{

	if(strLen(%n @ %n2 @ %n3) <= $MerpPref::NameCharLimit && %n !$= "")
	{

		if(%n2 $= ""){ %c.empireName = %n; }
		if(%n3 $= ""){ %c.empireName = %n SPC %n2; }
		if(%n3 !$= ""){ %c.empireName = %n SPC %n2 SPC %n3; }

		messageAll('MsgAdminForce',"\c6" @ %c.name SPC "has named their empire" @ %c.empireColor SPC %c.empireName);

	}
	if(strLen(%n @ %n2 @ %n3) > $MerpPref::NameCharLimit)
	{

		messageClient(%c,'',"\c6You must use an empire name under" SPC $MrepPref::NameCharLimit SPC "characters.");

	}
	if(%n $= "")
	{

		messageClient(%c,'',"\c6You did not specify anything.");

	}

}


package fixThatSymbol
{

	function serverCmdMessageSent(%c,%msg)
	{

		if(getSubStr(%msg,0,1) $= "<")
		{

			messageAll('',%c.empireColor @ "**" @ %c.empireName @ "\c6:" SPC getSubStr(%msg,1,strLen(%msg)));

		}

		else if(getSubStr(%msg,0,1) !$= "<")
		{

			parent::serverCmdMessageSent(%c,%msg);

		}

	}

	function gameConnection::autoAdminCheck(%c)
	{

		parent::autoAdminCheck(%c);

		messageClient(%c,'',"\c6/empirecolor [hex or colorset number] :: /empirename [name] :: /rgbtohex [r] [g] [b]");
		export("$MerpPref::*","./merpvar.cs");

	}

};
activatePackage(fixThatSymbol);

function serverCmdRoll(%c,%s)
{

	if(%s !$= "")
	{

		%num = getRandom(1,%s);
		messageAll('',"\c6" @ %c.name SPC "rolled a" SPC %num SPC "from a" SPC %s @ "-sided die.");

	}
	else
	{

		messageClient(%c,'',"You did not specify the amount of sides.");

	}

}
